;**********************************************************************
;(c) Copyright 1993, Blue Pearl Software, Mountain View, CA

;You may use this code for any purpose as long as it is not sold or
;included in any software toolkit with other tools and as long as
;the copyright notice is not removed.

;Enjoy... David Gassner, CIS:72077,2207; Tel: (415) 968-0545
;**********************************************************************

Proc MarkArray(ListArray,Choices,Desc)
  private NullVar,		;Null variable - target for button values
          Choice		;Current Choice from Dialog Box

Foreach Choice in ListArray	;Format array with Mark characters
  If Isassigned(Choices[Choice]) then
    ListArray[Choice] = Format("W44",ListArray[Choice]) + Chr(251)
  Else
    ListArray[Choice] = Substr(ListArray[Choice],1,44)
  Endif
Endforeach

Release Vars Choice		;Clear Choice, reset cursor location 
				;to top of List

SHOWDIALOG "Select "+Desc	;Start Dialog Box
   Proc "MarkArrayProc"
     Trigger "ACCEPT",		;Accept activates button actions
             "SELECT"		;Select marks/unmarks one array element

   @2,15 HEIGHT 21 WIDTH 51

   @13,15
      ?? Strval(Dynarraysize(Choices))+		;Records selected indicator
      " Record"+	
      Iif(Dynarraysize(Choices)=1,"","s")+
      " Selected"

   PICKDYNARRAY @2,1 HEIGHT 10 WIDTH 47		;Picklist
      COLUMNS 1
      ListArray
      TAG "Picklist"
      TO Choice

   LABEL @1,17
      "Mark ~R~ecords"
      FOR "Picklist"

   PUSHBUTTON @15,3 WIDTH 20			;Mark One Record button
      "~M~ark/Unmark"
      OK
      DEFAULT
      VALUE "Select"
      TAG "Select"
      TO NullVar

   PUSHBUTTON @15,27 WIDTH 20			;Finished button
      "~F~inished"
      Cancel 
      VALUE "Finished"
      TAG "Finished"
      TO NullVar

   PUSHBUTTON @17,13 WIDTH 24			;Mark All Records button
      "Mark/Unmark ~A~ll"
      OK
      VALUE "MarkAll"
      TAG "MarkAll"
      TO NullVar

ENDDIALOG

Return True

Endproc

;**********************************************************************

Proc MarkArrayProc(TriggerType,Element,EventInfo,NA)
  private ThisChoice

If TriggerType = "SELECT" or	;Double-Click, Spacebar or Mark button
   Element = "Select" then	;causes Mark/Unmark action

  If IsAssigned(Choices[Choice]) then		;Unmark if Marked
    ListArray[Choice] = Substr(ListArray[Choice],1,44)
    Release vars Choices[Choice]
  Else						;Mark if Unmarked
    ListArray[Choice] = Format("W44",ListArray[Choice]) + Chr(251)
    Choices[Choice] = True
  Endif

Else				;MarkAll Button has been pressed

  If Dynarraysize(Choices) = 0 then	;Mark All Records
    Foreach Thischoice in ListArray
      ListArray[Thischoice] = Format("W44",ListArray[Thischoice]) + Chr(251)
      Choices[Thischoice] = True
    Endforeach
  Else
    Foreach Thischoice in ListArray	;Unmark All Records
      ListArray[Thischoice] = Substr(ListArray[Thischoice],1,44)
      Release vars Choices[Thischoice]
    Endforeach
  Endif
Endif

Refreshcontrol "Picklist"
ResyncDialog
SelectControl "Picklist"

Return false			;Deny Accept or Select trigger

Endproc

;**********************************************************************
;                     Demo Section Starts Here!!
;**********************************************************************

Message "Scanning Customer Table . . ."

View "Customer"

Dynarray Customers[]			;Initialize Arrays
Dynarray CustomerChoices[]

Scan
  Customers[[Cust ID]] =		;Format Array Elements
    Format("W17",[Cust ID]) +
    [Last Name]+", " + [Init]
  CustomerChoices[[Cust ID]] = True     ;Start with All Selected
Endscan

Clearall				;Clear table image
Message ""				;Clear message

MarkArray(Customers,CustomerChoices,"Customers")	;Proc Call

Savevars CustomerChoices		;Developer gets to look at results!
Editor Open "Savevars.sc"
