;**********************************************************************
;(c) Copyright 1993, Blue Pearl Software, Mountain View, CA

;You may use this code for any purpose as long as it is not sold or
;included in any software toolkit with other tools and as long as
;the copyright notice is not removed.

;Enjoy... David Gassner, CIS:72077,2207; Tel: (415) 968-0545
;**********************************************************************

Proc MarkRecords(Choices,		;Marking Array - stored globally
                 Keyfield,		;Name of field to use as array index
                 Tbl,			;Name of table to mark from
                 MarkForm)		;Form to use

  Private Form.h,			;Form Handle
          Key,				;Key pressed
          Win.a				;Window Attributes Array

Message "Loading table"

View Tbl				;Open Table

Window Handle Current to Tbl.h		;Move Table image off screen
Window Move Tbl.h to 500,500

Pickform MarkForm			;Pick Form
Window Handle Form to Form.h		;Get Form Handle
CenterWindow(Form.h)

Prompt " [F2] Finish  [Spacebar] Mark/Unmark  [Ctrl+Spacebar] Mark/Unmark All"

MarkRecordsGetNumberMarked()

Echo Normal
Wait table
  Proc "MarkRecordsProc"
    Key "F2", " "
    Mouse "Down"
Endwait

Clearall

Endproc

;**********************************************************************

Proc MarkRecordsProc(TriggerType,EventInfo,NA)

If EventInfo["TYPE"] = "MOUSE" then	;Get mouse click
  Mouse Click EventInfo["ROW"], EventInfo["COL"]
  If EventInfo["DOUBLECLICK"] then
    Key = 32				;Change mouse event to key event
    EventInfo["Ctrl"] = False
  Else
    Return 1				;No double-click, all done!
  Endif
Else
  Key = EventInfo["KEYCODE"]		;Assign key value
Endif

Switch					;Now process keystrokes

  Case Key = 32 :			;Spacebar pressed

    If EventInfo["Ctrl"] then		;Mark/Unmark all records

      If Dynarraysize(Choices) = 0 then	;Mark All, since none are marked

        Message "Marking all records"
        Echo Off

        CurRecord = Recno()		;Get Current Cursor Location
        CurField = Field()
        CurRow = RowNo()

        Moveto Field Keyfield		;Go to key field

        Scan				;Build Choices array
          Choices[[]] = "\251"
        Endscan

        Moveto Record Currecord		;Reposition Cursor
        Moveto Field Curfield
        SetRecordPosition CurRecord CurRow

        Echo Normal			;Echo to Normal

      Else
        Foreach Choice in Choices
          Release Vars Choices[Choice]
        Endforeach
        Echo Off Echo Normal		;Refresh Screen
      Endif
  
    Else				;Mark/Unmark One Record

      Curfield = Field()		;Get cursor position
      Moveto Field Keyfield		;Get key value
      Keyvalue = []
      Moveto Field Curfield		;Return to current position

      If not isassigned(Choices[Keyvalue]) then		;Mark or unmark
        Choices[Keyvalue] = "\251"
      Else
        Release Vars Choices[Keyvalue]
      Endif

;----------------------------------------------------------------------
;Explanation required here:  The calculated field showing the mark character
;doesn't recalc unless there's some cursor movement.

      If Atlast() then		;If at end of table, do an Up then Down
        If AtFirst() then
          Echo Off Echo Normal
        Else
          Up Down
        Endif
      Else			;Otherwise, just go down
        Down
        If EventInfo["TYPE"] = "MOUSE" then
          Up
        Endif
      Endif

    Endif

    MarkRecordsGetNumberMarked()	;Display # of records marked

    Window Select Form.h		;Recover from any mouse clicks
					;which might have changed window
					;focus
    Return 1

  Case Key = Asc("F2") :		;Finish Wait with F2
    Return 2

  Otherwise :				;Process other keystrokes
    Return 0

Endswitch

Endproc

;**********************************************************************

Proc MarkRecordsGetNumberMarked()	;Displays a message indicating
					;how many records are marked
Message
  Strval(Dynarraysize(Choices)) +
  " Record" +
  Iif(Dynarraysize(Choices) = 1," is","s are") +
  " Marked"

Endproc

;**********************************************************************

Proc CenterWindow(Win.h)		;Centers a window on the screen
  Private Win.a,Sys.a

SysInfo to Sys.a		;Get screen size

Window GetAttributes		;Get window dimensions
   Win.h to Win.a

Win.a["ORIGINROW"] =
  Int((Sys.a["ScreenHeight"] -  ;Get Vertical position
  3 - Win.a["HEIGHT"])/2)+1

Win.a["ORIGINCOL"] =		;Get Horizontal position
  Int((Sys.a["ScreenWidth"] - 
  Win.a["WIDTH"])/2)

Window SetAttributes		;Set new window position
  Win.h from Win.a

Endproc

;**********************************************************************
;			THIS IS THE DEMO SECTION
;**********************************************************************

Dynarray CustomerChoices[]		;Set an empty array

MarkRecords(CustomerChoices,		;Call the procedure
            "Cust ID",
            "Customer",
            "1")

;do something with the CustomerChoices array here!!!!

savevars customerchoices		;Developer gets to peek at results!
editor open "Savevars.sc"
